package com.zgiot.zx.production.controller;


import com.zgiot.zx.production.base.Ret;
import com.zgiot.zx.production.utils.UUIDUtil;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.io.FileUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/filePath")
public class BaseAttFileController {

    @Value("${project.filePath}")
    private String filePath;

    private static final Logger logger = LoggerFactory.getLogger(BaseAttFileController.class);


    @ApiOperation(value="上传文件", notes="上传文件至服务器")
    @PostMapping("/upload")
    public Ret uploadFile(@RequestParam("file") @ApiParam(value="上传文件",required=true) MultipartFile file){
        String fileUuidName=UUIDUtil.getUUID();
        String fileUuidPath = UUIDUtil.getUUIDPath(fileUuidName);
        String FileSavePath = filePath + fileUuidPath;
        try {
            File dir = new File(FileSavePath);
            if (!dir.exists()) {
                dir.mkdirs();
            }
            //开始存储文件
            String fileName = file.getOriginalFilename();
            // 此处发现在IE 11中存在获取文件名时获取了文件路径，此处将文件路径去除
            if(fileName.indexOf(":\\")>-1){
                // 此时说明存在从根路径获取的内容  需要处理
                fileName = fileName.substring(fileName.lastIndexOf("\\") + 1, fileName.length());
            }
            String fileSuffix = fileName.substring(fileName.lastIndexOf(".") + 1, fileName.length());
            String newFileName = fileUuidName + "." + fileSuffix;
            FileUtils.copyInputStreamToFile(file.getInputStream(), new File(FileSavePath + newFileName));
            //开始返回文件的路径
            Map<String,String> result =new HashMap<String,String>();
            result.put("filePath",fileUuidPath+newFileName);
            return Ret.ok().setData(result);
        } catch (IOException e) {
            logger.error(e.getMessage(),e);
            return Ret.error().setMsg("文件上传异常，请检查");
        }
    }



}
