package com.zgiot.zx.production.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 数据同步更新记录表
 * </p>
 *
 * @author zhangyanduan
 * @since 2019-12-16
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("gm_data_log")
public class GmDataLog implements Serializable {

    private static final long serialVersionUID = 1L;


    /**
     * 主键
     */
    @TableId(value = "ID",type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 应用编码
     */
    @TableField("APP_CODE")
    private String appCode;


    /**
     * 批次编码
     */
    @TableField("BATCH_ID")
    private String batchId;

    /**
     * 开始ID
     */
    @TableField("SYNC_S_ID")
    private String syncSId;

    /**
     * 结束ID
     */
    @TableField("SYNC_E_ID")
    private String syncEId;

    /**
     * 开始时间
     */
    @TableField("SYNC_S_TIME")
    private LocalDateTime syncSTime;

    /**
     * 结束时间
     */
    @TableField("SYNC_E_TIME")
    private LocalDateTime syncETime;

    /**
     * 同步数据类型
     */
    @TableField("SYNC_DATA_SOURCE")
    private String syncDataSource;

    /**
     * 删除注记
     */
    @TableField("VILID_FLAG")
    private Integer vilidFlag;

    /**
     * 创建人
     */
    @TableField("CREATED_USER")
    private String createdUser;

    /**
     * 创建时间
     */
    @TableField("CREATED_TIME")
    private LocalDateTime createdTime;

    /**
     * 更新人
     */
    @TableField("MODIFY_USER")
    private String modifyUser;

    /**
     * 更新时间
     */
    @TableField("MODIFY_TIME")
    private LocalDateTime modifyTime;


}
