package com.zgiot.zx.production.utils;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.IdUtil;
import org.springframework.beans.factory.annotation.Value;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;
import java.util.Random;

public class UUIDUtil {


    @Value("${snowflake.client-id}")
    private static long clintId;
    @Value("${snowflake.client-id}")
    private static long dataCenterId;

    private static Snowflake snowflake;

    static{
        snowflake = IdUtil.createSnowflake(clintId, dataCenterId);
    }


    /**
     * 生成不带-的UUID
     *
     * @return UUID
     */
    public static String getUUID() {
        // 返回用UUID
        String uuidResult = "";
        // 临时用UUID
        String uuidTemp = "";
        // 取得UUID存储到临时用UUID
        uuidTemp = java.util.UUID.randomUUID().toString();

        // 替换掉所有-字符
        uuidResult = uuidTemp.replaceAll("-", "");

        // 返回UUID
        return uuidResult;
    }

    /**
     * java生成随机数字和字母组合
     *
     * @param length
     *            [生成随机数的长度]
     * @return
     */
    public static String getCharAndNumr(int length) {
        String val = "";
        Random random = new Random();
        for (int i = 0; i < length; i++) {
            // 输出字母还是数字
            String charOrNum = random.nextInt(2) % 2 == 0 ? "char" : "num";
            // 字符串
            if ("char".equalsIgnoreCase(charOrNum)) {
                // 取得大写字母还是小写字母
                int choice = random.nextInt(2) % 2 == 0 ? 65 : 97;
                val += (char) (choice + random.nextInt(26));
            } else if ("num".equalsIgnoreCase(charOrNum)) { // 数字
                val += String.valueOf(random.nextInt(10));
            }
        }
        return val;
    }

    /**
     * 随机生成纯数字
     *
     * @param length
     * @return
     */
    public static String getNumber(int length) {
        char[] chars = { '1', '2', '3', '4', '5', '6', '7', '8', '9', '0' };
        Random random = new Random();
        StringBuffer sb = new StringBuffer();
        for (int i = 1; i <= length; i++) {
            sb.append(chars[random.nextInt(chars.length)]);
        }
        return sb.toString();
    }


    /**
     * 获取雪花算法唯一ID
     * @return
     */
    public static long getSnowflakeId(){
        return snowflake.nextId();
    }




    /**
     * 根据UUID计算路径
     * @param uuid
     * @return
     */
    public static String getUUIDPath(String uuid){
        StringBuilder builder=new StringBuilder();
        builder.append("/");
        builder.append((uuid.substring(0, 3).hashCode())%100+"").append("/");
        builder.append((uuid.substring(7,10).hashCode())%100+"").append("/");
        builder.append((uuid.substring(11,14).hashCode())%100+"").append("/");
        return builder.toString();
    }

    public static void main(String[] args) {
//        System.out.println(UUIDUtil.getCharAndNumr(16));
//        System.out.println(UUIDUtil.getUUID());
//        for(int i=0;i<100;i++){
//            System.out.println(UUIDUtil.getUUID());
//        }
        //TODO 测试时间
//        String paramDate="2020-01-02";
//        DateTimeFormatter df=DateTimeFormatter.ofPattern("yyyy-MM-dd");
//        LocalDate localDate = LocalDate.parse(paramDate, df);
//        System.out.println(localDate.getDayOfMonth());
//        System.out.println(localDate.with(TemporalAdjusters.lastDayOfMonth()).getDayOfMonth());
//        System.out.println(localDate.with(TemporalAdjusters.lastDayOfMonth()).plusDays(1));
    }
}
